SystemOrganization addCategory: #TestableGraphics!

Object subclass: #CanvasContents
	instanceVariableNames: 'oldCanvasContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TestableGraphics'!

!CanvasContents methodsFor: 'as yet unclassified' stamp: 'hjo 3/26/2008 10:58'!
= aCanvasContents

	^self class = aCanvasContents class and: [
		oldCanvasContents = aCanvasContents oldCanvasContents
		]! !

!CanvasContents methodsFor: 'as yet unclassified' stamp: 'hjo 3/26/2008 09:57'!
draw: aCanvasContents

	^aCanvasContents oldCanvasContents: self! !

!CanvasContents methodsFor: 'as yet unclassified' stamp: 'hjo 3/26/2008 09:59'!
drawOn: aCanvas

	oldCanvasContents drawOn: aCanvas! !

!CanvasContents methodsFor: 'accessing' stamp: 'hjo 3/26/2008 09:47'!
oldCanvasContents

	^oldCanvasContents! !

!CanvasContents methodsFor: 'accessing' stamp: 'hjo 3/26/2008 09:47'!
oldCanvasContents: aCanvasContents

	oldCanvasContents := aCanvasContents! !

CanvasContents subclass: #NullCanvasContents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TestableGraphics'!

!NullCanvasContents methodsFor: 'as yet unclassified' stamp: 'hjo 3/26/2008 10:50'!
arrayOfPolygonPointsOn: aWriteStream 

	"do nothing"! !

!NullCanvasContents methodsFor: 'drawing' stamp: 'hjo 3/25/2008 15:38'!
drawOn: aFormCanvas 

	"do nothing"! !

CanvasContents subclass: #TestablePolyon
	instanceVariableNames: 'points borderWidth color borderColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TestableGraphics'!

!TestablePolyon methodsFor: 'as yet unclassified' stamp: 'hjo 3/26/2008 11:00'!
= aTestablePolygon

	^super = aTestablePolygon and: [
	color = aTestablePolygon color and: [
	borderColor = aTestablePolygon borderColor and: [
	points = aTestablePolygon points
			]]]! !

!TestablePolyon methodsFor: 'as yet unclassified' stamp: 'hjo 3/26/2008 10:50'!
arrayOfPolygonPointsOn: aWriteStream 

	oldCanvasContents arrayOfPolygonPointsOn: aWriteStream.
	aWriteStream nextPut: points! !

!TestablePolyon methodsFor: 'accessing' stamp: 'hjo 3/25/2008 15:20'!
borderColor

	^borderColor! !

!TestablePolyon methodsFor: 'accessing' stamp: 'hjo 3/25/2008 14:50'!
borderColor: aColor 

	borderColor := aColor! !

!TestablePolyon methodsFor: 'accessing' stamp: 'hjo 3/25/2008 14:49'!
borderWidth: aSmallInteger 
	
	borderWidth := aSmallInteger! !

!TestablePolyon methodsFor: 'accessing' stamp: 'hjo 3/25/2008 15:20'!
color

	^color! !

!TestablePolyon methodsFor: 'accessing' stamp: 'hjo 3/25/2008 14:50'!
color: aColor 

	color := aColor! !

!TestablePolyon methodsFor: 'as yet unclassified' stamp: 'hjo 3/26/2008 10:13'!
drawOn: aFormCanvas 

	super drawOn: aFormCanvas.
	aFormCanvas drawPolygon: points color: color borderWidth: borderWidth borderColor: borderColor! !

!TestablePolyon methodsFor: 'as yet unclassified' stamp: 'hjo 3/26/2008 10:57'!
hash

	^(super hash + points hash + color hash + borderColor hash) hash! !

!TestablePolyon methodsFor: 'accessing' stamp: 'hjo 3/25/2008 15:20'!
points

	^points! !

!TestablePolyon methodsFor: 'accessing' stamp: 'hjo 3/25/2008 14:48'!
points: anArray 

	points := anArray! !

Object subclass: #TestableCanvas
	instanceVariableNames: 'canvasContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TestableGraphics'!

!TestableCanvas classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/25/2008 15:22'!
showOn: aFormCanvas 
	self shouldBeImplemented! !

!TestableCanvas methodsFor: 'as yet unclassified' stamp: 'hjo 3/25/2008 15:15'!
= aTestableCanvas

	^canvasContents = aTestableCanvas canvasContents! !

!TestableCanvas methodsFor: 'as yet unclassified' stamp: 'hjo 3/26/2008 10:46'!
arrayOfPolygonPoints
	
	^Array streamContents: [ :stream | self arrayOfPolygonPointsOn: stream ]! !

!TestableCanvas methodsFor: 'as yet unclassified' stamp: 'hjo 3/26/2008 10:47'!
arrayOfPolygonPointsOn: aWriteStream 

	canvasContents arrayOfPolygonPointsOn: aWriteStream 
! !

!TestableCanvas methodsFor: 'accessing' stamp: 'hjo 3/25/2008 15:19'!
canvasContents

	^canvasContents! !

!TestableCanvas methodsFor: 'as yet unclassified' stamp: 'hjo 3/25/2008 14:47'!
drawPolygon: anArray color: aColor borderWidth: aSmallInteger borderColor: aColor2

	canvasContents := canvasContents draw:
		(TestablePolyon new
			points: anArray;
			borderWidth: aSmallInteger;
			color: aColor;
			borderColor: aColor2)! !

!TestableCanvas methodsFor: 'as yet unclassified' stamp: 'hjo 3/25/2008 15:16'!
hash

	^canvasContents hash! !

!TestableCanvas methodsFor: 'as yet unclassified' stamp: 'hjo 3/25/2008 15:05'!
initialize

	super initialize.
	canvasContents := NullCanvasContents new! !

!TestableCanvas methodsFor: 'as yet unclassified' stamp: 'hjo 3/25/2008 15:23'!
showOn: aFormCanvas 

	canvasContents drawOn:aFormCanvas! !
